## snap-aligner 0.18~1.0~beta.18%2Bdfsg1

=== Makefile ===
ifndef CXXFLAGS
  CXXFLAGS = -O3 -Wno-format
endif

CXXFLAGS += -MMD -ISNAPLib -msse

LDFLAGS += -pthread

#LIBHDFS_HOME = ../hadoop-2.2.0-src/hadoop-hdfs-project/hadoop-hdfs/src/main/native/libhdfs
#JAVA_HOME = /usr/lib/jvm/java-7-oracle

ifdef LIBHDFS_HOME
  CXXFLAGS += -DSNAP_HDFS -I$(LIBHDFS_HOME)
  LDFLAGS += -L$(LIBHDFS_HOME) -L$(JAVA_HOME)/jre/lib/amd64/server -L$(JAVA_HOME)/jre/lib/amd64
  LIBS +=  -lhdfs -ljvm
endif

UNAME := $(shell uname)

ifeq ($(UNAME), Linux)
  LIBS += -lrt -lz
endif

ifeq ($(UNAME), Darwin)
  LIBS += -lz
endif

CXX = g++

LIB_SRC = $(wildcard SNAPLib/*.cpp)
LIB_OBJ = $(patsubst %.cpp, %.o, $(LIB_SRC))

SNAP_SRC = $(wildcard apps/snap/*.cpp)
TEST_SRC = $(wildcard tests/*.cpp)
ROC_SRC = $(wildcard apps/ComputeROC/*.cpp)
SNAPCOMMAND_SRC = $(wildcard apps/SNAPCommand/*.cpp)

SNAP_OBJ = $(patsubst %.cpp, %.o, $(SNAP_SRC))
TEST_OBJ = $(patsubst %.cpp, %.o, $(TEST_SRC))
ROC_OBJ = $(patsubst %.cpp, %.o, $(ROC_SRC))
SNAPCOMMAND_OBJ = $(patsubst %.cpp, %.o, $(SNAPCOMMAND_SRC))

ALL_OBJ = $(LIB_OBJ) $(SNAP_OBJ) $(TEST_OBJ) $(SNAPCOMMAND_OBJ)

DEPS = $(pathsubst %.o, %.d, $(ALL_OBJ))

EXES = snap-aligner unit_tests SNAPCommand

default: $(EXES)

-include $(pathsubst %.o, %.d, $(ALL_OBJ))

$(OBJS): %.o : %.cpp
	$(CXX) -o $@ $(CXXFLAGS) -c $< 

snap-aligner: $(LIB_OBJ) $(SNAP_OBJ)
	$(CXX) -o $@ $(CXXFLAGS) -Itests $(LDFLAGS) $^ $(LIBS)

SNAPCommand: $(LIB_OBJ) $(SNAPCOMMAND_OBJ)
	echo SNAPCOMMAND_OBJ is $(SNAPCOMMAND_OBJ)
	echo SNAP_OBJ is $(SNAP_OBJ)
	$(CXX) -o $@ $(CXXFLAGS) $(LDFLAGS) $^ $(LIBS)

snapxl:
	make clean
	make snap CXXFLAGS="-DLONG_READS $(CXXFLAGS)"
	mv snap snapxl
	make clean

roc: $(LIB_OBJ) $(ROC_OBJ)
	$(CXX) -o $@ $(CXXFLAGS) -Itests $(LDFLAGS) $^ $(LIBS)

unit_tests: $(LIB_OBJ) $(TEST_OBJ)
	$(CXX) -o $@ $(CXXFLAGS) -Itests $(LDFLAGS) $^ $(LIBS)

clean:
	rm -f $(ALL_OBJ) $(DEPS) $(EXES) snap SNAP

.phony: clean default

## snap-aligner 0.18~1.0~beta.18+dfsg1

=== debian/changelog ===
snap-aligner (0.18~1.0~beta.18+dfsg1-2) unstable; urgency=medium

  * Drop -msse flag for wider platform compatibility
    Closes: #812376

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Sun, 24 Jan 2016 01:25:27 -0800

snap-aligner (0.18~1.0~beta.18+dfsg1-1) unstable; urgency=low

  * Initial release (Closes: #800340)

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Sat, 19 Sep 2015 20:20:26 -0700

=== debian/control ===
Source: snap-aligner
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@ucdavis.edu>
Build-Depends: debhelper (>= 9),
               help2man,
               zlib1g-dev
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/cgit/debian-med/snap-aligner.git
Vcs-Git: git://anonscm.debian.org/debian-med/snap-aligner.git
Homepage: http://snap.cs.berkeley.edu/

Package: snap-aligner
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Scalable Nucleotide Alignment Program
 SNAP is a new sequence aligner that is 3-20x faster and just as accurate as
 existing tools like BWA-mem, Bowtie2 and Novoalign. It runs on commodity x86
 processors, and supports a rich error model that lets it cheaply match reads
 with more differences from the reference than other tools. This gives SNAP up
 to 2x lower error rates than existing tools (in some cases) and lets it match
 larger mutations that they may miss. SNAP also natively reads BAM, FASTQ, or
 gzipped FASTQ, and natively writes SAM or BAM, with built-in sorting,
 duplicate marking, and BAM indexing.

=== debian/rules ===
#!/usr/bin/make -f

DEBVERS        := $(shell dpkg-parsechangelog | awk '/^Version:/ {print $$2}')
VERSION        := $(shell echo '$(DEBVERS)' | sed -e 's/^[0-9]*://' -e 's/-.*//')
%:
	dh $@

override_dh_auto_test:
	dh_auto_test
	./unit_tests

override_dh_auto_build:
	dh_auto_build
	help2man --no-discard-stderr --no-info --version-string="${VERSION}" \
		--name "scalable nucleotide alignment program" \
		--help-option=" " ./snap-aligner > debian/snap-aligner.1
	for option in index single paired; do help2man \
		--no-discard-stderr --no-info --version-string="${VERSION}" \
		--include=debian/snap-aligner-$${option}-man-include \
		--help-option=" " "./snap-aligner $${option}" > \
		debian/snap-aligner-$${option}.1; done
	help2man --no-discard-stderr --no-info --version-string="${VERSION}" \
		--name "scalable nucleotide alignment program" \
		--help-option=" " ./SNAPCommand > debian/SNAPCommand.1

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/*.1
	rm -f */*.d */*/*.d

=== debian/watch ===
version=3

#upstrea uses GitHub but numbers their release in a way that I don't know how
#to de-mangle
#
#Example version number: 0.14, 0.15, 1.0beta.18, 1.0beta.19

# Uncomment to find new files on Github
#  - when using releases:
# https://github.com/#GITHUBUSER#/#PACKAGE#/releases .*/archive/#PREFIX#(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
#  - when using tags
# https://github.com/#GITHUBUSER#/#PACKAGE#/tags .*/#PREFIX#(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
# Remark: frequently you can do s/#PREFIX#/v?/ since 'v' or nothing is quite common but there are other prefixes possible

# if you need to repack and choose +dfsg prefix
# opts=dversionmangle=s/[~\+]dfsg[0-9]*// \
#

## snap-aligner 1.0~beta.18+dfsg

=== debian/changelog ===
snap-aligner (1.0~beta.18+dfsg-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:58:09 +0100

snap-aligner (1.0~beta.18+dfsg-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target
  * Install NOTICE.txt of Apache licensed files
  * Propagate hardening options

  [ Liubov Chuprikova ]
  * Add missing return in a non-void function

 -- Andreas Tille <tille@debian.org>  Sun, 03 Feb 2019 12:11:59 +0100

snap-aligner (1.0~beta.18+dfsg-2) unstable; urgency=medium

  * Team upload
  * Restrict package to 64 bit architectures only
    Closes: #860652
  * Standards-Version: 4.1.2
  * Do not parse d/changelog

 -- Andreas Tille <tille@debian.org>  Thu, 21 Dec 2017 09:50:14 +0100

snap-aligner (1.0~beta.18+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New versioning scheme closer to upstream
  * d/watch:
     - Try proper version mangling
     - Repack + xz compression
  * debhelper 10
  * hardening=+all

 -- Andreas Tille <tille@debian.org>  Fri, 02 Dec 2016 20:36:12 +0100

snap-aligner (0.18~1.0~beta.18+dfsg1-4) unstable; urgency=medium

  * Build with -std=gnu++98, closes: 831138

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 05 Aug 2016 01:00:41 -0700

snap-aligner (0.18~1.0~beta.18+dfsg1-3) unstable; urgency=medium

  * Add support for kfreebsd and non-x86, thanks to Aaron M. Ucko
    <ucko@debian.org> (Closes: #812551, #812550)
  * Drop attempt at 32-bit compatibility, as per upstream we need >4GB memory
    space for real uses of this tool.

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Wed, 24 Feb 2016 13:15:12 -0800

=== debian/control ===
Source: snap-aligner
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               help2man,
               zlib1g-dev
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/med-team/snap-aligner
Vcs-Git: https://salsa.debian.org/med-team/snap-aligner.git
Homepage: http://snap.cs.berkeley.edu/

Package: snap-aligner
Architecture: amd64 arm64 mips64el ppc64el alpha kfreebsd-amd64 ppc64 sparc64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Scalable Nucleotide Alignment Program
 SNAP is a new sequence aligner that is 3-20x faster and just as accurate as
 existing tools like BWA-mem, Bowtie2 and Novoalign. It runs on commodity x86
 processors, and supports a rich error model that lets it cheaply match reads
 with more differences from the reference than other tools. This gives SNAP up
 to 2x lower error rates than existing tools (in some cases) and lets it match
 larger mutations that they may miss. SNAP also natively reads BAM, FASTQ, or
 gzipped FASTQ, and natively writes SAM or BAM, with built-in sorting,
 duplicate marking, and BAM indexing.

=== debian/rules ===
--- 
+++ 
@@ -1,13 +1,21 @@
 #!/usr/bin/make -f
 
-DEBVERS        := $(shell dpkg-parsechangelog | awk '/^Version:/ {print $$2}')
-VERSION        := $(shell echo '$(DEBVERS)' | sed -e 's/^[0-9]*://' -e 's/-.*//')
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+include /usr/share/dpkg/default.mk
+VERSION        := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/+dfsg//')
+
+CXXFLAGS := -std=gnu++98
+export CXXFLAGS
+
 %:
 	dh $@
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	dh_auto_test
 	./unit_tests
+endif
 
 override_dh_auto_build:
 	dh_auto_build

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz,uversionmangle=s/beta/~beta/" \
  https://github.com/amplab/snap/releases .*/archive/v(\d[-\d.beta]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## snap-aligner 1.0.0+dfsg

=== debian/changelog ===
snap-aligner (1.0.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 01 Oct 2021 11:29:05 +0200

snap-aligner (1.0.0+dfsg-2) unstable; urgency=medium

  * debian/rules: The file in the examples folder with the incorrect execute
    bit is from the debian/ directory, so fix the permission there instead of
    the hack previously used.

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 29 Nov 2020 10:24:29 +0100

snap-aligner (1.0.0+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * Freshen patches.
  * debian/docs: Update filename of the manual
  * debian/control: try building on s390x and riscv64
  * Enable building on non-x86 systems via libsimde-dev
  * debian/patches/fix_segfault: patch from upstream to fix a segfault I found
    during testing.

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 29 Nov 2020 08:44:51 +0100

snap-aligner (1.0~beta.18+dfsg-4) unstable; urgency=medium

  [ Steffen Moeller ]
  * d/u/metadata: yamllint

  [ Pranav Ballaney ]
  * Install example and reference data
  * Add autopkgtests
  * Install docs
  * Add Pranav Ballaney to Uploaders

  [ Michael R. Crusoe ]
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse
  * Fixed another spelling error

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 09 Jul 2020 11:00:43 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,21 @@
 Source: snap-aligner
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
+Uploaders: Michael R. Crusoe <crusoe@debian.org>,
+           Pranav Ballaney <ballaneypranav@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 13),
                help2man,
-               zlib1g-dev
-Standards-Version: 4.3.0
+               zlib1g-dev,
+               libsimde-dev
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/snap-aligner
 Vcs-Git: https://salsa.debian.org/med-team/snap-aligner.git
 Homepage: http://snap.cs.berkeley.edu/
+Rules-Requires-Root: no
 
 Package: snap-aligner
-Architecture: amd64 arm64 mips64el ppc64el alpha kfreebsd-amd64 ppc64 sparc64
+Architecture: amd64 arm64 mips64el ppc64el s390x alpha kfreebsd-amd64 ppc64 riscv64 sparc64
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: Scalable Nucleotide Alignment Program

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz,uversionmangle=s/beta/~beta/" \
  https://github.com/amplab/snap/releases .*/v(\d[-\d.beta]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## snap-aligner 2.0.2%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -8,10 +8,10 @@
                help2man,
                zlib1g-dev,
                libsimde-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/snap-aligner
 Vcs-Git: https://salsa.debian.org/med-team/snap-aligner.git
-Homepage: http://snap.cs.berkeley.edu/
+Homepage: https://snap.cs.berkeley.edu/
 Rules-Requires-Root: no
 
 Package: snap-aligner

## snap-aligner 2.0.2+dfsg

=== debian/changelog ===
snap-aligner (2.0.2+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * d/watch:
     - Use tags instead of releases
     - Add filenamemangle option
  * Standards-Version: 4.6.2 (routine-update)
  * Use secure URI in Homepage field.
  * Update comparison files of autopkgtest

 -- Andreas Tille <tille@debian.org>  Wed, 01 Feb 2023 20:24:38 +0100

## snap-aligner 2.0.3+dfsg

=== debian/changelog ===
snap-aligner (2.0.3+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Add loong64 to list of architectures
    Closes: #1050330, #1059989

 -- Andreas Tille <tille@debian.org>  Thu, 11 Jan 2024 21:49:06 +0100

snap-aligner (2.0.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Remove program version from reference file to not being forced to
    adapt the reference for every new release

 -- Andreas Tille <tille@debian.org>  Thu, 24 Aug 2023 11:17:57 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 Rules-Requires-Root: no
 
 Package: snap-aligner
-Architecture: amd64 arm64 mips64el ppc64el s390x alpha kfreebsd-amd64 ppc64 riscv64 sparc64
+Architecture: amd64 arm64 mips64el ppc64el s390x alpha kfreebsd-amd64 ppc64 riscv64 sparc64 loong64
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: Scalable Nucleotide Alignment Program

## snap-aligner 2.0.5+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 ifndef CXXFLAGS
-  CXXFLAGS = -O3 -Wno-format
+  CXXFLAGS = -O3 -Wno-format -std=c++98
+  #CXXFLAGS = -g -O0 -Wno-format -std=c++98
 endif
 
 CXXFLAGS += -MMD -ISNAPLib -msse
@@ -23,6 +24,11 @@
 
 ifeq ($(UNAME), Darwin)
   LIBS += -lz
+endif
+
+ifneq ($(STATIC),)
+  STATIC_GCC=-static-libgcc -static-libstdc++
+  LIBS += $(STATIC_GCC)
 endif
 
 CXX = g++

=== debian/changelog ===
snap-aligner (2.0.5+dfsg-1) unstable; urgency=medium

  * d/control: simplify architecture specification via the provisions
    from the architecture-properties package.
  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * Refreshed patches.
  * Added patch to fix typo.

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 05 Sep 2025 13:52:21 +0200

=== debian/control ===
--- 
+++ 
@@ -5,17 +5,18 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               architecture-is-64-bit,
                help2man,
                zlib1g-dev,
                libsimde-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/snap-aligner
 Vcs-Git: https://salsa.debian.org/med-team/snap-aligner.git
 Homepage: https://snap.cs.berkeley.edu/
 Rules-Requires-Root: no
 
 Package: snap-aligner
-Architecture: amd64 arm64 mips64el ppc64el s390x alpha kfreebsd-amd64 ppc64 riscv64 sparc64 loong64
+Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: Scalable Nucleotide Alignment Program

=== debian/rules ===
--- 
+++ 
@@ -5,8 +5,7 @@
 include /usr/share/dpkg/default.mk
 VERSION        := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/+dfsg//')
 
-CXXFLAGS := -std=gnu++98
-export CXXFLAGS
+export DEB_CXXFLAGS_MAINT_APPEND=-std=gnu++98 -O3 -fopenmp-simd -DSIMDE_ENABLE_OPENMP
 
 %:
 	dh $@

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,uversionmangle=s/beta/~beta/,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/amplab/snap/tags .*/v(\d[-\d.beta]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
